import java.io.*;
import java.util.*;
import java.net.*;
import java.security.*;
import java.math.*;
import java.lang.Math.*;

public class smilFile
{
    public String createSmilFile(String mainVideo, String textInfo, String adVideo,
                                    String newsFeed)
    {
        String smil = "";
        String qt = "\"";
        String font = "serif";
        String fontsize = "16px";
        String wrap = "noWrap";
        String bgcolor = "navy";
        String textcolor = "white";
        String style = "mystyle";
        String textregion = "mytext";
        String wtextregion = "weathertext";
        String tr_top = "260"; /* tr = textregion */
        String tr_left = "10";
        String tr_width = "360";
        String tr_height = "20";
        String tr_textmode = "crawl";
        String tr_textrate = "20px";

        smil += "<smil>\n";
        smil += "<head>\n\n";
        smil += "<textStyling>\n";
        
        smil += "<textStyle xml:id="+ qt + style + qt + " textFontFamily=" + qt + font + qt + 
                " textFontSize=" + qt + fontsize + qt + " textWrapOption=" + qt + wrap + qt +
                " textColor=" + qt + textcolor + qt + " textBackgroundColor=" + qt + bgcolor + qt
                + "/>\n";
        
        smil += "</textStyling>\n\n";

        smil += "<layout>\n";
        smil += "<region id=" + qt + textregion + qt + " top=" + qt + tr_top + qt + " width=" +
                qt + tr_width + qt + " left=" + qt + tr_left + qt + " height=" + 
                qt + tr_height + qt + " textMode=" + qt + tr_textmode + qt +
                " textRate=" + qt + tr_textrate + qt + " textStyle=" + qt + style + qt+ "/>\n";       
        smil += "<region id=" + qt + wtextregion + qt + " top=" + qt + tr_top + qt + " width=" +
                qt + "270" + qt + " left=" + qt + tr_left + qt + " height=" + 
                qt + tr_height + qt + "/>\n";       

        smil += "</layout>\n\n";
        smil += "</head>\n\n";

        smil += "<body>\n";
        smil += "<par>\n";
        smil += "<video src=" + qt + mainVideo + qt + " clip-begin=" + qt + "0s" + qt + 
                " clip-end=" + qt + "20s" + qt + " />\n";
        smil += "<text src=" + qt + textInfo + qt + " region=" + qt + wtextregion + qt +
                " background-color=" + qt + "yellow" + qt + " />\n";
        smil += "</par>\n";

        smil += "<par>\n";
        smil += "<video src=" + qt + adVideo + qt + " />\n";
        smil += "<smilText region=" + qt + textregion + qt + ">\n" +   
                "                         This is an advt. Your video will resume shortly " +  
                "</smilText>\n";

        smil += "</par>\n";
        smil += "<par>\n";
        smil += "<video src=" + qt + mainVideo + qt + " clip-begin=" + qt + "19s" + qt + " />\n";
        smil += "<smilText xml:id=" + qt + "smiltext_1" + qt + " region=" + qt + textregion + qt
                + " textAlign=" + qt + "right" + qt + " >\n";

        smil += newsFeed;
        smil += "</smilText>\n";
        smil += "</par>\n";
        smil += "</body>\n";
        smil += "</smil>\n";

        return (smil);
    }

    public String getSmilNewsFeed()
    {
        try {
            File f = new File(new File(".").getCanonicalPath() + "/text/news.txt");
            BufferedReader br = new BufferedReader(new FileReader(f));
            String s;
            String smil = "                               * BBC latest news feed * ";

            while ((s = br.readLine()) != null) {
                smil += " * " + s + "\n";
                smil += "<tev next= \"1s\" />\n";
            }
            return (smil);
        } catch (Exception e) {
        }
        return "news feed missing!\n";
    }

    public String getRandomAd()
    {
        try {
            File dir = new File(new File(".").getCanonicalPath() + "/video");
            String files[] = dir.list();
            Random gen = new Random();
            int r = Math.abs(gen.nextInt());

            if (files.length != 0) {
                return (files[r % files.length]);
            } else {
                return "";
            }
        } catch (Exception e) {
            System.out.println(e);
        }
        return "";
    }

    public String getSmilFileWithOverlays(String url)
    {
        String smil = "";
        String localUrl = "";
        URL u = null;
        String local;
        CacheVideo c = new CacheVideo();
        overlayInfo o = new overlayInfo();

        o.weatherInit();
        o.newsFeedInit();

        try {
            u = new URL(url);
        } catch (Exception e) {
        }

        local = c.getFileForURL(u).substring(1);
        localUrl = "http://" + CacheVideo.getHostName() + ":81" +  local;
        String vurl = "http://" + CacheVideo.getHostName() + ":81" + "/video/" +
                       this.getRandomAd();
        String textUrl = "http://" + CacheVideo.getHostName() + ":81" + "/text/weather.txt";

        smil = this.createSmilFile(localUrl, textUrl, vurl, this.getSmilNewsFeed());
        return smil;
    }

    public int getSmilFile(String url)
    {
        String file;
        smilFile o = new smilFile();
        URL u = null;
        CacheVideo c = new CacheVideo();
        try {
            u = new URL(url);
        } catch (Exception e) {
            System.out.println("Malformed url\n");
        }

        file = c.getFileForURL(u);
        File f = new File(file);

        if (!f.exists()) {
            return (0);
        } 
        return (1);
    }

    public String getNew(String url)
    {
        return ("<smil>\n<body>\n<video src = \"" + url + "\"/>\n</body>\n</smil>");
    }
}





