package weatherprovider.locationdatamodel;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import java.util.ArrayList;

/**
 * SearchLocations is a container of SearchLocation objects
 *
 * @author Nazmul Idris
 * @since Jan 1, 2007, 9:28:55 PM
 */
public class SearchLocations {
  protected ArrayList<SearchLocation> _searchLocations = new ArrayList<SearchLocation>();

  public void add( SearchLocation sl ){
    _searchLocations.add( sl );
  }

  public ArrayList<SearchLocation> getSearchLocations(){
    return _searchLocations;
  }

  public String toString(){
    return ToStringBuilder.reflectionToString( this , ToStringStyle.NO_FIELD_NAMES_STYLE );
  }
}

