package weatherprovider.weatherdatamodel;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Value Object bean for BarometricPressure.
 * <p/>
 */
public class BarometricPressure {
  private String trend;
  private String pressure;

  public String getTrend() {
    return trend;
  }

  public void setTrend(String description) {
    this.trend = description;
  }

  public String getPressure() {
    return pressure;
  }

  public void setPressure(String pressure) {
    this.pressure = pressure;
  }

  public String toString() {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.SHORT_PREFIX_STYLE);
  }

}

