package weatherprovider.weatherdatamodel;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Half-a-day, either day or night.
 * <p/>
 * After 2pm for the current Day, the day day-part will not be returned.
 * <p/>
 */
public class DayPart {
  private String description;
  private String humidity;
  private String icon;
  private String partId;
  private String precipitation;
  private Wind wind;

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public String getHumidity() {
    return humidity;
  }

  public void setHumidity(String humidity) {
    this.humidity = humidity;
  }

  public String getIcon() {
    return icon;
  }

  public void setIcon(String icon) {
    this.icon = icon;
  }

  public String getPartId() {
    return partId;
  }

  public void setPartId(String partId) {
    this.partId = partId;
  }

  public String getPrecipitation() {
    return precipitation;
  }

  public void setPrecipitation(String precipitation) {
    this.precipitation = precipitation;
  }

  public Wind getWind() {
    return wind;
  }

  public void setWind(Wind wind) {
    this.wind = wind;
  }

  public String toString() {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.SHORT_PREFIX_STYLE);
  }

}

