package weather_service.weatherprovider.weatherdatamodel;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Header info, containing the units in use throughout the feed.
 * <p/>
 */
public class Header {

  private String locale;
  private String form;
  private String temperatureUnit;
  private String distanceUnit;
  private String speedUnit;
  private String pressureUnit;
  private String precipitationUnit;

  public String getDistanceUnit() {
    return distanceUnit;
  }

  public void setDistanceUnit(String distanceUnit) {
    this.distanceUnit = distanceUnit;
  }

  public String getForm() {
    return form;
  }

  public void setForm(String form) {
    this.form = form;
  }

  public String getLocale() {
    return locale;
  }

  public void setLocale(String locale) {
    this.locale = locale;
  }

  public String getPrecipitationUnit() {
    return precipitationUnit;
  }

  public void setPrecipitationUnit(String precipitationUnit) {
    this.precipitationUnit = precipitationUnit;
  }

  public String getPressureUnit() {
    return pressureUnit;
  }

  public void setPressureUnit(String pressureUnit) {
    this.pressureUnit = pressureUnit;
  }

  public String getSpeedUnit() {
    return speedUnit;
  }

  public void setSpeedUnit(String speedUnit) {
    this.speedUnit = speedUnit;
  }

  public String getTemperatureUnit() {
    return temperatureUnit;
  }

  public void setTemperatureUnit(String temperatureUnit) {
    this.temperatureUnit = temperatureUnit;
  }

  public String toString() {
    return ToStringBuilder.reflectionToString(this, ToStringStyle.NO_FIELD_NAMES_STYLE);
  }

}

